/*-
 * ~~~~~~licensing~~~~~~
 * core-support-runtime
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.support.runtime.cxf;

import java.util.ArrayList;
import java.util.List;

import org.osgi.framework.wiring.BundleWiring;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.entaxy.platform.core.support.runtime.EntaxyResourceURLCachingClassLoader;
import ru.entaxy.platform.core.support.runtime.EntaxyResourceURLClassLoader;

public class EntaxyCxfClassResourceUnwrapper extends EntaxyCxfDelegatingClassUnwrapper {

	private static final Logger log = LoggerFactory.getLogger(EntaxyCxfClassResourceUnwrapper.class);
	
	protected List<String> resourceFolders = new ArrayList<>();
	
	protected boolean useCache = false;
	
	@Override
	protected ClassLoader createClassLoader() {
		if (resourceFolders != null) {
			EntaxyResourceURLClassLoader cl = null;
			if (delegate == null) {
				if (useCache) {
					cl = new EntaxyResourceURLCachingClassLoader(this.bundleContext==null
							?this.getClass().getClassLoader()
							:this.bundleContext.getBundle().adapt(BundleWiring.class).getClassLoader()
					);
					
				} else {
					cl = new EntaxyResourceURLClassLoader(this.bundleContext==null
									?this.getClass().getClassLoader()
									:this.bundleContext.getBundle().adapt(BundleWiring.class).getClassLoader()
							);
				}
				cl.setResourcePath(resourceFolders);
			}
			return cl;
		}
		return null;
	}

	public List<String> getResourceFolders() {
		return resourceFolders;
	}

	public void setResourceFolders(List<String> resourceFolders) {
		this.resourceFolders = resourceFolders;
	}

	public boolean isUseCache() {
		return useCache;
	}

	public void setUseCache(boolean useCache) {
		this.useCache = useCache;
	}
	
}
